﻿Public Class Form1

    Dim IntPrv_ListIndex As Integer = -1

    #Region "Sub SetServerAccountInfo : サーバー名、アカウントの設定."
        Private Sub SetServerAccountInfo()
            Try
                With ClsPub_POP3
                    ' サーバー名の設定.
                    .ServerName = Me.Txt_Name.Text.Trim

                    ' アカウント名の設定.
                    .AccountName = Me.Txt_Account.Text.Trim()

                    ' パスワードの設定.
                    .Password = Me.Txt_Password.Text.Trim()

                End With
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Form1_FormClosing : フォームクローズ."
        Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
            Try
                ' 開放します.
                ClsPub_POP3.Cls_Dispose
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Form1_Load : フォームロード."
        Private Sub Form1_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                Me.ListView1.Columns(0).Width = 150
                Me.ListView1.Columns(1).Width = 300
                Me.ListView1.Columns(2).Width = 150
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Count_Click : 件数取得."
        Private Sub Btn_Count_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Count.Click
            Dim Back_Cursors As Cursor = System.Windows.Forms.Cursor.Current    ' カーソルをバックアップします.
            Try
                ' カーソルを砂時計にします.
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
                ' サーバー名、アカウントの設定.
                SetServerAccountInfo()

                Dim Int_DataCount As Integer = ClsPub_POP3.GetMessageCount()
                If Int_DataCount = -1 Then
                    ' エラー発生.
                    MsgBox(ClsPub_POP3.GetErrMsg())
                Else
                    ' 件数を表示します.
                    Dim Str_Msg As String
                    Str_Msg = "メール件数：" & Convert.ToString(Int_DataCount) & ControlChars.CrLf
                    Str_Msg += "メッセージのサイズ：" & Convert.ToString(ClsPub_POP3.GetMessageSize())
                    MsgBox(Str_Msg)
                End If

            Catch ex As Exception
            Finally
                ' カーソルを元に戻します.
                System.Windows.Forms.Cursor.Current = Back_Cursors
            End Try
        End Sub
    #End Region

    #Region "メッセージのリスト表示."
        #Region "Sub Btn_List_Click : リストボタンのクリック."
            Private Sub Btn_List_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_List.Click
                Try
                    Btn_List_Click_Sub()
                Catch ex As Exception
                Finally
                End Try
            End Sub
        #End Region

        #Region "Sub Btn_List_Click_Sub : メッセージをリスト表示します."
            Private Sub Btn_List_Click_Sub()
                Dim Back_Cursors As Cursor = System.Windows.Forms.Cursor.Current    ' カーソルをバックアップします.
                Try
                    ' カーソルを砂時計にします.
                    System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
                    ' サーバー名、アカウントの設定.
                    SetServerAccountInfo()

                    Dim Cls_SimpleHeaderInfo() As NSDPOP3.POP3_SIMPLE_HEADER_INFO = Nothing
                    If ClsPub_POP3.GetMessageList(0, 0, Cls_SimpleHeaderInfo) Then
                        IntPrv_ListIndex = -1
                        With Me.ListView1
                            .Items.Clear
                            If Not (Cls_SimpleHeaderInfo Is Nothing) Then
                                For Int_Loop As Integer = 0 To Cls_SimpleHeaderInfo.Length - 1
                                    Dim Str_FromName As String = Cls_SimpleHeaderInfo(Int_Loop).FromName
                                    If String.IsNullOrEmpty(Str_FromName) Then
                                        Str_FromName = Cls_SimpleHeaderInfo(Int_Loop).FromAddress
                                    End If
                                    Dim LvItem As ListViewItem = .Items.Add(Str_FromName)
                                    With LvItem
                                        ' 件名をセット.
                                        .SubItems.Add(Cls_SimpleHeaderInfo(Int_Loop).Subject)
                                        ' 送信日時をセット.
                                        .SubItems.Add(Format(Cls_SimpleHeaderInfo(Int_Loop).SenderDay, "yyyy/MM/dd (ddd) HH:mm"))
                                        ' メッセージIDをセット.
                                        .Tag = Cls_SimpleHeaderInfo(Int_Loop).MessegeID
                                    End With
                                Next Int_Loop
                            End If
                            If .Items.Count <> 0 Then
                                .Items(0).Selected = True

                                Me.GroupBox1.Enabled = True
                                Me.Btn_RawHeaderInfo.Enabled = True
                                Me.Btn_RawDataInfo.Enabled = True
                            Else
                                MsgBox("メッセージがありません。")
                            End If
                        End With
                    Else
                        ' エラー発生.
                        MsgBox(ClsPub_POP3.GetErrMsg())
                    End If
                Catch ex As Exception
                Finally
                    ' カーソルを元に戻します.
                    System.Windows.Forms.Cursor.Current = Back_Cursors
                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub ListView1_SelectedIndexChanged : メッセージの選択."
        Private Sub ListView1_SelectedIndexChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles ListView1.SelectedIndexChanged
            Try
                If Not (CType(sender, ListView).SelectedItems.Count = 0) Then
                IntPrv_ListIndex = CType(sender, ListView).SelectedItems(0).Index
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Clear_Click : メッセージリストをクリアします."
        Private Sub Btn_Clear_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Clear.Click
            Try
                Me.ListView1.Items.Clear
                Me.GroupBox1.Enabled = False
                Me.Btn_RawHeaderInfo.Enabled = False
                Me.Btn_RawDataInfo.Enabled = False
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Details_Click : 詳細設定ボタン."
        Private Sub Btn_Details_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Details.Click
            Try
                Using fm As New Form3
                    fm.ShowDialog
                End Using
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub RadioButton1_CheckedChanged : inlineデータを本文に追加する."
        Private Sub RadioButton1_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
            Try
                If CType(sender, RadioButton).Checked Then
                    ClsPub_POP3.inlineAttachmentStyle = NSDPOP3.ATTACHMENT_STYLE.inline_Body
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub RadioButton2_CheckedChanged : inlineデータを添付ファイルにする."
        Private Sub RadioButton2_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged
            Try
                If CType(sender, RadioButton).Checked Then
                    ClsPub_POP3.inlineAttachmentStyle = NSDPOP3.ATTACHMENT_STYLE.inline_Attachments
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub RadioButton3_CheckedChanged : inlineデータを本文に追加しない."
        Private Sub RadioButton3_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RadioButton3.CheckedChanged
            Try
                If CType(sender, RadioButton).Checked Then
                    ClsPub_POP3.inlineAttachmentStyle = NSDPOP3.ATTACHMENT_STYLE.inline_NoBody
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_RawHeaderInfo_Click : 加工なしのヘッダー情報を表示します."
        Private Sub Btn_RawHeaderInfo_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_RawHeaderInfo.Click
            Dim Back_Cursors As Cursor = System.Windows.Forms.Cursor.Current    ' カーソルをバックアップします.
            Try
                ' カーソルを砂時計にします.
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
                ' サーバー名、アカウントの設定.
                SetServerAccountInfo()

                Dim Str_HeaderInfo As String = ClsPub_POP3.GetRawHeaderInfo(IntPrv_ListIndex + 1)
                If Not String.IsNullOrEmpty(Str_HeaderInfo) Then
                    Using fm As New Form4
                        fm.Text = "加工なしのヘッダー情報"
                        fm.TextBox1.Text = Str_HeaderInfo
                        fm.ShowDialog()
                    End Using
                Else
                    ' エラー発生.
                    MsgBox(ClsPub_POP3.GetErrMsg())
                End If

            Catch ex As Exception
            Finally
                ' カーソルを元に戻します.
                System.Windows.Forms.Cursor.Current = Back_Cursors
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_RawDataInfo_Click : 加工なしのデータ情報を表示します."
        Private Sub Btn_RawDataInfo_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_RawDataInfo.Click
            Dim Back_Cursors As Cursor = System.Windows.Forms.Cursor.Current    ' カーソルをバックアップします.
            Try
                ' カーソルを砂時計にします.
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
                ' サーバー名、アカウントの設定.
                SetServerAccountInfo()

                Dim Str_DataInfo As String = ClsPub_POP3.GetRawMessageInfo(IntPrv_ListIndex + 1)
                If Not String.IsNullOrEmpty(Str_DataInfo) Then
                    Using fm As New Form4
                        fm.Text = "加工なしのデータ情報"
                        fm.TextBox1.Text = Str_DataInfo
                        fm.ShowDialog()
                    End Using
                Else
                    ' エラー発生.
                    MsgBox(ClsPub_POP3.GetErrMsg())
                End If
            Catch ex As Exception
            Finally
                ' カーソルを元に戻します.
                System.Windows.Forms.Cursor.Current = Back_Cursors
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_HeaderInfo_Click : ヘッダー情報を表示します."
        Private Sub Btn_HeaderInfo_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_HeaderInfo.Click
            Dim Back_Cursors As Cursor = System.Windows.Forms.Cursor.Current    ' カーソルをバックアップします.
            Try
                ' カーソルを砂時計にします.
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
                ' サーバー名、アカウントの設定.
                SetServerAccountInfo()

                If ClsPub_POP3.GetHeaderInfo(IntPrv_ListIndex + 1, ClsPub_HeaderInfo) Then
                    Using fm As New Form2
                        fm.IntFrd_ViewInfo = Form2.VIEWINFO.Header
                        fm.Text = "詳細情報"
                        fm.ShowDialog
                    End Using
                Else
                    ' エラー発生.
                    MsgBox(ClsPub_POP3.GetErrMsg())
                End If

            Catch ex As Exception
            Finally
                ' カーソルを元に戻します.
                System.Windows.Forms.Cursor.Current = Back_Cursors
            End Try

        End Sub
    #End Region

    #Region "Sub Btn_DataInfo_Click : データ情報を表示します."
        Private Sub Btn_DataInfo_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_DataInfo.Click
            Dim Back_Cursors As Cursor = System.Windows.Forms.Cursor.Current    ' カーソルをバックアップします.
            Try
                ' カーソルを砂時計にします.
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
                ' サーバー名、アカウントの設定.
                SetServerAccountInfo()
                Dim Str_Text As String = Nothing
                If ClsPub_POP3.GetMessageInfo(IntPrv_ListIndex + 1, ClsPub_HeaderInfo, Str_Text) Then
                    ClsPub_Text = Str_Text
                    Using fm As New Form2
                        fm.IntFrd_ViewInfo = Form2.VIEWINFO.All
                        fm.Text = "データ取得"
                        fm.ShowDialog
                        If BlnPub_Delete Then
                            MsgBox("データ数が変更されましたので、リストを再取得します。")
                            Btn_List_Click_Sub()
                        End If
                    End Using
                Else
                    ' エラー発生.
                    MsgBox(ClsPub_POP3.GetErrMsg())
                End If
            Catch ex As Exception
            Finally
                ' カーソルを元に戻します.
                System.Windows.Forms.Cursor.Current = Back_Cursors
            End Try
        End Sub
    #End Region

End Class
